#declare shapes=
// generic
// fluted and helical ring shapes 

isosurface {
 function { 1-                            
  //min ( // for merge
  max ( // for intersection and difference
  //sqrt((x*x)+(z*z))-y // cone
  sqrt((x*x)+(y*y)+(z*z))*1.0 // sphere 
  ,sqrt((x*x)+(z*z))*1.5 // cylinder
  //,sqrt((x*x)+(z*z))*y*1.0 // trumpet
  )// min
  //-(x/2) // skew
  //
  //surface modifier
  //
  -sin ( atan2(x,z)*30)*0.02 // fluting 
  //-sin ( atan2(x,z)*5)*0.1 // fluting 5 wave
  //-sin (y*2*pi*2)*0.05 // rings
  -sin ( (y*2*pi*2) + (atan2(x,z)*4) ) *0.1 // normal helical
 }
 threshold 0
 //contained_by { box{<-4,-4,-4>,< 4, .7, 4> }  }
 contained_by {sphere {0,3}}
 open
 max_gradient 3
 scale 2
}

#declare knee=
// fluted and helical ring shapes
isosurface {
 function { 1-                            
  min ( // for merge
  sqrt((x*x)+(y*y)+(z*z))*1.0 // sphere 
  ,sqrt((x*x)+(z*z))*1.5 // cylinder
  )
  -sin ( atan2(x,z)*30)*0.02 // fluting 
  //-sin ( atan2(x,z)*5)*0.1 // fluting 5 wave
  //-sin (y*2*pi*2)*0.05 // rings
  -sin ( (y*2*pi*2) + (atan2(x,z)*4) ) *0.1 // normal helical
 }
 threshold 0
 //contained_by { box{<-4,-4,-4>,< 4, .7, 4> }  }
 contained_by {sphere {0,3}}
 open
 max_gradient 3
}

#declare fluted_helix=
isosurface {
 function { 1-                            
  max ( // for intersection and difference
  sqrt((x*x)+(y*y)+(z*z))*1.0 // sphere 
  ,sqrt((x*x)+(z*z))*1.5 // cylinder
  )
  -sin ( atan2(x,z)*30)*0.02 // fluting 
  -sin ( (y*2*pi*2) + (atan2(x,z)*4) ) *0.1 // normal helical
 }
 threshold 0
 contained_by {sphere {0,3}}
 open
 max_gradient 3
 scale 2
}

#declare helical_cylinder=
isosurface {
 function { 1-                            
  -sqrt((x*x)+(z*z))*1.5 // cylinder
  -sin ( (y*2*pi*2) + (atan2(x,z)*4) ) *0.1 // normal helical
 }
 threshold 0
 contained_by {sphere {0,3}}
 open
 max_gradient 3
}


#declare helical_trumpet=
isosurface {
 function { 1-                            
  -sqrt((x*x)+(z*z))*y*1.0 // trumpet
  -sin ( (y*2*pi*2) + (atan2(x,z)*4) ) *0.1 // normal helical
 }
 threshold 0
 contained_by {sphere {0,3}}
 open
 max_gradient 3
}

#declare bell=
// fluted and helical ring shapes
isosurface {
 function { 1-                            
  sqrt((x*x)+(y*y)+(z*z))*1.3 // sphere 
  +sqrt((x*x)+(z*z))*y // trumpet
  -sin ( atan2(x,z)*30)*0.05 // fluting 
  -sin ( atan2(x,z)*5)*0.1 // fluting 5 wave
 }
 threshold 0
 contained_by { box{<-4,-4,-4>,< 4, .7, 4> }  }
 open
 max_gradient 3
}

#declare daffodil=
// fluted and helical ring shapes
isosurface {
 function { 1-                            
  sqrt((x*x)+(y*y)+(z*z))*1.3 // sphere 
  +sqrt((x*x)+(z*z))*y // trumpet
  -sin ( atan2(x,z)*30)*0.05 // fluting 
  -sin ( atan2(x,z)*5)*0.1 // fluting 5 wave
 }
 threshold 0
 contained_by {sphere {0,2.5}}
 open
 max_gradient 3
}

#declare pillow=
isosurface {
 function { 1                            
  -sqrt((x*x)+(z*z))*1.0 // cylinder
  -sqrt((x*x)+(y*y))*1.0 // cylinder
 }
 contained_by {sphere {0,1}}
 open
 max_gradient 4
}


#declare eye_piece=
isosurface {
 function { 1                            
  -sqrt((x*x)+(z*z))*1.0 // cylinder
  +sqrt((x*x)+(y*y))*0.4 // cylinder
 }
 contained_by {sphere {0,6} }
 open
 max_gradient 4
 rotate 90*y
}

#declare pip=
isosurface {
 function { 1                            
  -sqrt((x*x)+(y*y)+(z*z))*1.0 // sphere
  -sqrt((x*x)+(z*z))*1.0 // cylinder
 }
 contained_by {sphere {0,6} }
 open
 max_gradient 4
 rotate 90*y
}

#declare spindle=
isosurface {
 function { 1                            
  -sqrt((x*x)+(y*y)+(z*z))*0.2
  -sqrt((x*x)+(z*z))*1.0 // cylinder
 }
 contained_by {sphere {0,4} }
 open
 max_gradient 4
 rotate 90*y
}
#
declare lentil=
isosurface {
 function { 1                            
  -sqrt((x*x)+(y*y)+(z*z))*0.5
  -sqrt((y*y))
 }
 contained_by {sphere {0,4} }
 open
 max_gradient 4
}

declare inflated_octagon=
isosurface {
 function { 1                            
  -sqrt((x*x)+(y*y)+(z*z))
  -sqrt((x*x))/3
  -sqrt((y*y))/3
  -sqrt((z*z))/3
 }
 contained_by {sphere {0,1} }
 open
 max_gradient 4
 scale 3
}

declare double_carton=
isosurface {
 function { 1                            
  -sqrt((x*x)+(y*y)+(z*z))
  -sqrt((x*x))/3
  +sqrt((y*y))/3
  -sqrt((z*z))/3
 }
 contained_by {sphere {0,1} }
 open
 max_gradient 4
 scale 3
}

declare nipple=
isosurface {
 function { 1                            
  -sqrt((x*x)*2+(y*y)+(z*z))*(y/2+1)
 }
 contained_by {sphere {0,3} }
 open
 max_gradient 4
 scale 1
}



declare rounded_cube=
isosurface {
 function { 1                            
  -sqrt((x*x*x*x)+(y*y*y*y)+(z*z*z*z))
}
 contained_by {sphere {0,3} }
 open
 max_gradient 5
 scale 3
}

declare extra_rounded_cube=
isosurface {
 function { 1                            
  -sqrt((x*x*x*x)+(y*y*y*y)+(z*z*z*z))
  -sqrt((x*x)+(y*y)+(z*z))
}                              
 contained_by {sphere {0,1 } }
 open
 max_gradient 5
 scale 2
 scale 1
}

declare grain=
isosurface {
 function { 1                            
  -sqrt((x*x*x*x)+(y*y*y*y)+(z*z*z*z))
  -sqrt((x*x)+(z*z))
}                              
 contained_by {sphere {0,1 } }
 open
 max_gradient 5
 scale 2
}

declare inflated_crescent=
isosurface {
 function {
  f_torus ( x,y,z, 0.5, 0.1 )
  -z/4
  }                              
 contained_by {sphere {0,4 } }
 open
 max_gradient 5
 scale 4
} 

declare rings=
isosurface {
 function {
 min (
  f_torus ( x,y,z, 0.5, 0.1 )
  ,f_torus ( x-1,y,z, 0.5, 0.1 ) 
  ,f_torus ( x+1,y*0.2,z, 0.5, 0.1 ) 
  )
  }                              
 contained_by {sphere {0,4 } }
 open
 max_gradient 5
 scale 2
}




//#declare f_helix1 = function { internal(25) }
// Parameters: x, y, z 
// Parameters: x, y, z
    // Seven extra parameters required: 
    // 1. Number of helixes - e.g. 2 for a double helix 
    // 2. Period - is related to the number of turns per unit length 
    // 3. Minor radius 
    // 4. Major radius 
    // 5. Shape parameter. If this is greater than 1 then the tube becomes fatter in the y direction 
    // 6. Cross section type. 
    // 7. Cross section rotation angle (degrees). E.g. if you choose a square cross section and rotate it by 45 degrees you get a diamond cross section.

declare helices=
isosurface {
 function {
  f_helix1 (
    x,y,z,
    1,  // number of helixes
    -4, // number of turns
    0.2, 0.5, // minor_radius major_radius
    1, 1, 0 ) // flattening  cross_section_type cross_section_rotation                         
 }                              
 contained_by {sphere {0,4 } }
 open
 max_gradient 5
 //rotate -90*x
 scale 1
}

declare tori=
isosurface {
 function {
  f_torus ( x,y,z, 0.5, 0.1 )
  //f_torus2 ( x,y,z, 0.2, 0.5, 0.1 )
  }                              
 contained_by {sphere {0,4 } }
 open
 max_gradient 5
 //rotate -90*x
 scale 1
}


#declare drip=
isosurface {
function {
 f_glob(x,y,z,0.1)
}
contained_by { sphere {<-1,0,0>, 1.0}}
open
 //rotate -90*x
translate <1,ht,0>
}

#declare comma=
isosurface {
function {
 f_comma(x,y,z,1)
}
contained_by { sphere {<0,0,0>, 1.0}}
open
 rotate -90*x
translate <0,ht,0>
}

#declare flask=
isosurface {
function {
 f_lemniscate_of_gerono(x,y,z,1)
}
contained_by { sphere {<0,0,0>, 1}} // 1,15
max_gradient 2
open
 //rotate -90*y
translate <0,ht,0>
}

#declare dimple=
isosurface {
function {
 f_odd (x,y,z,.1)
}
contained_by { sphere {<0,0,0>, 1}} 
max_gradient 4
open
 rotate 25*y
translate <0,ht,0>
}

#declare drip1=
isosurface {
function {
 f_piriform (x,y,z,.9)
}
contained_by { sphere {<0,0,0>, 1}} 
max_gradient 4
open
 //rotate 90*y
translate <0,ht,0>
}

#declare rounded_cube=
isosurface {
function {
 f_rounded_box (x,y,z, .2, 1,1,1)
}
contained_by { box {-2, 2}} 
max_gradient 1
open
 //rotate 90*y
translate <0,ht,0>
}



////////////////////////////////////////////////////////////////////



#declare many_shapes=                 
object { shapes 
 pigment { rgb 1 }
 finish { ambient 0.5 }
 //scale <1,2,1>
 scale 1
 rotate -30*x
 rotate -180*x
 translate <0,ht,ds>
}
object { many_shapes }

